;7-8.exe, restores a file that has been compressed with 8-7.exe
;To see it in action, try for example:
;echo Hello|8-7|7-8
;8-7 | 7-8 <sometextfile

comment|  sample build file:
@echo off
\masm32\bin\ml /c /coff 7-8.asm
if errorlevel 1 goto end
\masm32\bin\polink /SUBSYSTEM:CONSOLE /STACK:4096,4096 /HEAP:4096,4096 7-8.obj
del 7-8.obj
rem dosstub 7-8.exe    optional
dir 7-8.exe
:end
|

.386
.model flat, stdcall
option casemap:none

include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

ReadBuff_ equ 200h     ;buffer sizes
WriteBuff_ equ 200h

.data
ExitAddress  dd ?
hRead        dd ?
ReadBuff     dd ?
amtReadBuff  dd 0
ptrReadBuff  dd ?
hWrite       dd ?
WriteBuff    dd ?
amtWriteBuff dd WriteBuff_
ptrWriteBuff dd ?

.code
Start:
    pop ExitAddress
    sub esp,ReadBuff_
    mov ReadBuff,esp
    sub esp,WriteBuff_
    mov WriteBuff,esp
    mov ptrWriteBuff,esp
    invoke GetStdHandle,-10   ; -10 = STD_INPUT_HANDLE
    mov hRead,eax
    invoke GetStdHandle,-11   ; -11 = STD_OUTPUT_HANDLE
    mov hWrite,eax
OuterLoop:
    mov ah,0
    mov ecx,7
InnerLoop:
    mov bh,ah       ;save ah
    call GetByte
    js short Finish ;This won't happen if the input to 7-8.exe is legitimate.
    mov ah,bh
    xchg al,ah
    rol al,cl
    rol al,1
    shr ax,cl
    shr al,1
    jz Finish
    call PutByte
    loop InnerLoop
    mov al,ah
    or al,al
    jz short Finish
    call PutByte
    jmp short OuterLoop
Finish:
    call FlushWrite
    xor eax,eax
    jmp ExitAddress

PutByte:
    mov edi,ptrWriteBuff
    stosb
    mov ptrWriteBuff,edi
    dec amtWriteBuff
    jnz @F
    call FlushWrite
@@: ret

FlushWrite:
    push eax
    mov eax,ptrWriteBuff
    mov edx,WriteBuff
    sub eax,edx
    push ecx
    invoke WriteFile,hWrite,edx,eax,addr amtWriteBuff,0
    pop ecx
    mov amtWriteBuff,WriteBuff_
    mov eax,WriteBuff
    mov ptrWriteBuff,eax
    pop eax
    ret

GetByte:   ;returns a byte in al, from the read handle, or SF if end-of-file.
    mov esi,offset amtReadBuff
    dec dword ptr[esi]
    jns short @F   ;if read buffer is empty, read more of the input
    push ecx
    invoke ReadFile,hRead,ReadBuff,ReadBuff_,esi,0
    pop ecx
    mov eax,[esi]          ;amount read
    dec eax
    js short GetByte_ret
    mov [esi],eax
    mov eax,ReadBuff
    mov ptrReadBuff,eax
@@: mov esi,ptrReadBuff
    lodsb
    mov ptrReadBuff,esi
GetByte_ret:
    ret

end Start
