;8-7.exe, compresses 7-bit ascii text which contains no zeros
comment|   sample build file:
@echo off
\masm32\bin\ml /c /coff 8-7.asm
if errorlevel 1 goto end
\masm32\bin\polink /SUBSYSTEM:CONSOLE /STACK:4096,4096 /HEAP:4096,4096 8-7.obj
del 8-7.obj
rem dosstub 8-7.exe   optional
dir 8-7.exe
:end
|

.386
.model flat, stdcall
option casemap:none

include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

ReadBuff_ equ 200h     ;buffer sizes
WriteBuff_ equ 200h

.data
ExitAddress  dd ?
hRead        dd ?
ReadBuff     dd ?
amtReadBuff  dd 0
ptrReadBuff  dd ?
hWrite       dd ?
WriteBuff    dd ?
amtWriteBuff dd WriteBuff_
ptrWriteBuff dd ?

.code
Start:
    pop ExitAddress
    sub esp,ReadBuff_
    mov ReadBuff,esp
    sub esp,WriteBuff_
    mov WriteBuff,esp
    mov ptrWriteBuff,esp
    invoke GetStdHandle,-10   ; -10 = STD_INPUT_HANDLE
    mov hRead,eax
    invoke GetStdHandle,-11   ; -11 = STD_OUTPUT_HANDLE
    mov hWrite,eax
OuterLoop:
    call GetByte
    js short DoneOuter  ;input size is a multiple of 8
    and al,7Fh
    mov ah,al
    mov ecx,7
InnerLoop:
    mov bh,ah
    call GetByte
    mov ah,bh
    js short DoneInner  ;input size is not a multiple of 8
    call PutByte1
    loop InnerLoop
    jmp short OuterLoop

DoneInner:
    call PutByte1_0
DoneOuter:
    mov al,0
    call PutByte
    call FlushWrite
    xor eax,eax
    jmp ExitAddress

PutByte1_0:
    mov al,0
PutByte1:
    ror ah,cl
    rol ax,cl
PutByte:         ;input is al
    mov edi,ptrWriteBuff
    stosb
    mov ptrWriteBuff,edi
    dec amtWriteBuff
    jnz short @F
    call FlushWrite
@@: ret

FlushWrite:
    push eax
    mov eax,ptrWriteBuff
    sub eax,WriteBuff
    push ecx
    invoke WriteFile,hWrite,WriteBuff,eax,addr amtWriteBuff,0
    pop ecx
    mov amtWriteBuff,WriteBuff_
    mov eax,WriteBuff
    mov ptrWriteBuff,eax
    pop eax
    ret

GetByte:   ;returns a byte in AL, from the read handle, or SF if end-of-file.
    mov esi,offset amtReadBuff
    dec dword ptr[esi]
    jns short @F   ;if read buffer is empty, read more of the input
    push ecx
    invoke ReadFile,hRead,ReadBuff,ReadBuff_,esi,0
    pop ecx
    mov eax,[esi]          ;amount read
    dec eax
    js short GetByte_ret
    mov [esi],eax
    mov eax,ReadBuff
    mov ptrReadBuff,eax
@@: mov esi,ptrReadBuff
    lodsb
    mov ptrReadBuff,esi
GetByte_ret:
    ret

end Start
